Subject: Re: Making git push output quieter

From: Albert Astals Cid <[email-masked]>
Date: Wed, 5 Aug 2009 21:13:06 +0200

A Dimecres, 5 d'agost de 2009, Pau Garcia i Quiles va escriure:
> On Tue, Aug 4, 2009 at 11:27 PM, Albert Astals Cid<[email-masked]> wrote:
> > Hi, at KDE we are starting to try to use git and one of the things that's
> > bothering me is that git push is too verbose for our scripts.
> >
> > We have some scripts that commit things and i get the diff of previous
> > runs, if there is no diff it means all worked fine, a diff means
> > something i have to look at.
> >
> > Now i'm getting diffs like
> >
> > -Counting objects: 23, done.
> > +Counting objects: 53, done.
> >  Delta compression using up to 2 threads.
> > -Compressing objects:   8% (1/12)   Compressing objects:  16% (2/12)
> > Compressing objects:  25% (3/12)   Compressing objects:  33% (4/12)
> > Compressing objects:  41% (5/12)   Compressing objects:  50% (6/12)
> > Compressing objects:  58% (7/12)   Compressing objects:  66% (8/12)
> > Compressing objects:  75% (9/12)   Compressing objects:  83% (10/12)
> > Compressing objects:  91% (11/12)   Compressing objects: 100% (12/12)
> > Compressing objects: 100% (12/12), done.
> > -Writing objects:   8% (1/12)   Writing objects:  16% (2/12)   Writing
> > objects:  25% (3/12)   Writing objects:  33% (4/12)   Writing objects:
> >  41% (5/12)   Writing objects:  50% (6/12)   Writing objects:  58% (7/12)
> >   Writing objects:  66% (8/12)   Writing objects:  75% (9/12)   Writing
> > objects:  83% (10/12)   Writing objects:  91% (11/12)   Writing objects:
> > 100% (12/12) Writing objects: 100% (12/12), 1.05 KiB, done.
> > -Total 12 (delta 11), reused 0 (delta 0)
> > +Compressing objects:   3% (1/29)   Compressing objects:   6% (2/29)
> > Compressing objects:  10% (3/29)   Compressing objects:  13% (4/29)
> > Compressing objects:  17% (5/29)   Compressing objects:  20% (6/29)
> > Compressing objects:  24% (7/29)   Compressing objects:  27% (8/29)
> > Compressing objects:  31% (9/29)   Compressing objects:  34% (10/29)
> > Compressing objects:  37% (11/29)   Compressing objects:  41% (12/29)
> > Compressing objects:  44% (13/29)   Compressing objects:  48% (14/29)
> > Compressing objects:  51% (15/29)   Compressing objects:  55% (16/29)
> > Compressing objects:  58% (17/29)   Compressing objects:  62% (18/29)
> > Compressing objects:  65% (19/29)   Compressing objects:  68% (20/29)
> > Compressing objects:  72% (21/29)   Compressing objects:  75% (22/29)
> > Compressing objects:  79% (23/29)   Compressing objects:  82% (24/29)
> > Compressing objects:  86% (25/29)   Compressing objects:  89% (26/29)
> > Compressing objects:  93% (27/29)   Compressing objects:  96% (28/29)
> >  Compressing objects: 100% (29/29)   Compressing objects: 100% (29/29),
> > done. +Writing objects:   3% (1/29)   Writing objects:   6% (2/29)  
> > Writing objects:  10% (3/29)   Writing objects:  13% (4/29)   Writing
> > objects:  17% (5/29)   Writing objects:  20% (6/29)   Writing objects:
> >  24% (7/29)   Writing objects:  27% (8/29)   Writing objects:  31% (9/29)
> >   Writing objects:  34% (10/29)   Writing objects:  37% (11/29)   Writing
> > objects:  41% (12/29) Writing objects:  44% (13/29)   Writing objects:
> >  48% (14/29)   Writing objects:  51% (15/29)   Writing objects:  55%
> > (16/29)   Writing objects:  62% (18/29)   Writing objects:  65% (19/29)  
> > Writing objects:  68% (20/29) Writing objects:  72% (21/29)   Writing
> > objects:  75% (22/29)   Writing objects:  79% (23/29)   Writing objects:
> >  82% (24/29)   Writing objects:  86% (25/29)   Writing objects:  89%
> > (26/29)   Writing objects:  93% (27/29) Writing objects:  96% (28/29)  
> > Writing objects: 100% (29/29)   Writing objects: 100% (29/29), 4.46 KiB,
> > done.
> > +Total 29 (delta 23), reused 0 (delta 0)
> >  => Syncing Gitorious... [OK]
> >  To [email-masked]:amarok/amarok.git
> > -   f7863f9..f4370ae  HEAD -> master
> > +   1a1b30f..670cb0e  HEAD -> master
> >
> > That really are not a problem and are filling my diffs for no reason. We
> > could redirect to > /dev/null the git push command but then i would not
> > see if anything failed.
> >
> > Is it possible to make git push just output data when failing? And if not
> > do you think it's a worthwhile feature i can ask for? Do you have a
> > formal way for feature requests?
>
> Have you tried redirecting only stdout to /dev/null, and keeping
> stderr to yourself ?

Everything goes to stderr.

> In addition to that, exit code != 0 means
> something went wrong.

I could make something with this, but is it really not something that should 
happen that errors go to stderr and regular text to stdout?

Albert